; Modified/tested for Gimp.2.10.34 by MrQ 
;
; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; Separate Sharpening, V1.1 for GIMP 2.4
; Original author: Martin Egger (martin.egger@gmx.net)
; (C) 2005, Bern, Switzerland
;
; Tags: photo, sharpen
;
;
; You can find more about Separate Sharpening at
; http://thomas-stoelting.de/photoshop.html
;
;
; --------------------------------------------------------------------
; Distributed by Gimp FX Foundry project
; --------------------------------------------------------------------
;   - Changelog -
;
; --------------------------------------------------------------------
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;.
; Define the function
;
(define (script-fu-Eg-SeparateSharpen InImage InLayer InRadius InAmount InThreshold InFlatten)
;
; Save history			
;
	(gimp-image-undo-group-start InImage)
;
	(let*	(
		(SharpenLightsLayer (car (gimp-layer-copy InLayer TRUE)))
		)
;
		(gimp-image-add-layer InImage SharpenLightsLayer -1)
   		(gimp-layer-set-mode SharpenLightsLayer LAYER-MODE-LIGHTEN-ONLY-LEGACY)
   		(gimp-layer-set-opacity SharpenLightsLayer 40)
		(plug-in-unsharp-mask TRUE InImage SharpenLightsLayer InRadius InAmount InThreshold)
;
		(let*	(
			(SharpenShadowsLayer (car (gimp-layer-copy SharpenLightsLayer TRUE)))
			)
			(gimp-image-add-layer InImage SharpenShadowsLayer -1)
			(gimp-layer-set-mode SharpenShadowsLayer LAYER-MODE-DARKEN-ONLY-LEGACY)
			(gimp-layer-set-opacity SharpenShadowsLayer 100)
		
;
; Flatten the image, if we need to
;
			(cond
				((= InFlatten TRUE)
					(begin
						(let*	(
							(SharpenLightsLayer (car (gimp-image-merge-down InImage SharpenShadowsLayer CLIP-TO-IMAGE)))
							)
							(gimp-image-merge-down InImage SharpenLightsLayer CLIP-TO-IMAGE)
						)
					)
				)
				((= InFlatten FALSE)
					(begin
						(gimp-drawable-set-name SharpenLightsLayer _"Sharpened Lights")
						(gimp-drawable-set-name SharpenShadowsLayer _"Sharpened Shadows")
						(gimp-image-set-active-layer InImage InLayer)
					)
				)
			)
		)
	)
;
; Finish work
;
	(gimp-image-undo-group-end InImage)
	(gimp-displays-flush)
;
)
;
(script-fu-register 
	"script-fu-Eg-SeparateSharpen"
	_"Separate _Lights&Shadows Sharpen..."
	_"Separate Sharpening (Lights & Shadows)"
	"Martin Egger (martin.egger@gmx.net)"
	"Martin Egger, Bern, Switzerland"
	"20.10.2007"
	"RGB* GRAY*"
	SF-IMAGE	"The Image"		0
	SF-DRAWABLE	"The Layer"		0
	SF-ADJUSTMENT	_"Radius of USM"		'(3.0 0.0 50.0 1 0 2 0)
	SF-ADJUSTMENT	_"Amount of USM"		'(1.0 0.0 5.0 0.5 0 2 0)
	SF-ADJUSTMENT	_"Threshold"		'(0.0 0.0 50.0 1.0 0 2 0)
	SF-TOGGLE	_"Flatten Image"		FALSE
)
;
(script-fu-menu-register "script-fu-Eg-SeparateSharpen"
			 "<Image>/FX-Foundry/Egger")
;
